using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.DirectoryServices;

namespace ELOS
{
    public partial class ELOS : Form
    {
        // Variabls being used by the program.
        List<string> SID = new List<string>();
        string ELOAdminSID = "";
        string ELOUserSID = "";
        int count = 0;
        List<int> fouls = new List<int>();
        bool visibelcorret = false;
        
        public ELOS()
        {
            InitializeComponent();
        }

        // Function started if there is a click on button "Get Usergroups" 
        private void getGroups_Click(object sender, EventArgs e)
        {
            listBox1.Items.Clear();
            // Test if anything is entered in the ADServer field.
            if (ADServer.TextLength == 0)
            {
                listBox1.Items.Add("Please enter the name on the AD-server");
            }
            else
            {
                // The try is here in case the the AD-server is not found and a 
                // exeption i casted.
                try
                {
                    ADGrouplist.Items.Clear();
                    SID.Clear();
                    // Call to the AD-server to get all user-groups and their SID.
                    DirectoryEntry ADentry = new DirectoryEntry("LDAP://" + ADServer.Text);
                    DirectorySearcher ADsearch = new DirectorySearcher(ADentry);
                    ADsearch.Filter = ("(objectclass=group)");
                    foreach (System.DirectoryServices.SearchResult ADresult in ADsearch.FindAll())
                    {
                        ADGrouplist.Items.Add(ADresult.GetDirectoryEntry().Name.ToString());
                        SID.Add(new System.Security.Principal.SecurityIdentifier((byte[])ADresult.GetDirectoryEntry().Properties["objectSid"][0], 0).Value.ToString());
                    }
                }
                catch (Exception exp)
                {
                    listBox1.Items.Add("The servername entered is not correct or");
                    listBox1.Items.Add("there is no connection to the server");
                    listBox1.Items.Add("Message from windows: "+exp.Message.ToString());
                }
            }
        }
        // Function started if there is a click on button "Get Admin Group" 
        private void getAdmin_Click(object sender, EventArgs e)
        {
            // Sendes the name of the Admin group to the ELOAdmin-field if one is selected.
            try
            {
                ELOAdmin.Text = ADGrouplist.SelectedItem.ToString();
                ELOAdminSID = SID[ADGrouplist.SelectedIndex].ToString();
            }
            catch
            {
                ELOAdmin.Text = "No group selected.";
            }      
        }
        // Function started if there is a click on button "Get User Group" 
        private void getUser_Click(object sender, EventArgs e)
        {
            // Sendes the name of the User group to the ELOUser-field if one is selected.
            try
            {
                ELOUser.Text = ADGrouplist.SelectedItem.ToString();
                ELOUserSID = SID[ADGrouplist.SelectedIndex].ToString();
            }
            catch
            {
                ELOUser.Text = "No group selected.";
            }
        }
        // Function started if there is a click on button "Choose folder" (ELO archive folder)
        private void Choosefolder1_Click(object sender, EventArgs e)
        {
            // Startes a browser dialog window and sets the path to the flder
            // selected in the ELOArchive-field
            folderBrowserDialog1.Reset();
            DialogResult foldersucces = folderBrowserDialog1.ShowDialog();
            if (foldersucces == DialogResult.OK)
            {
                ELOArchive.Text = folderBrowserDialog1.SelectedPath;
            }
        }
        // Function started if there is a click on button "Choose folder" (ELO Global folder) 
        private void Choosefolder2_Click(object sender, EventArgs e)
        {
            // Startes a browser dialog window and sets the path to the flder
            // selected in the ELOGlobal-field
            folderBrowserDialog1.Reset();
            DialogResult foldersucces = folderBrowserDialog1.ShowDialog();
            if (foldersucces == DialogResult.OK)
            {
                ELOGlobal.Text = folderBrowserDialog1.SelectedPath;
            }
        }
        // Function started if there is a click on button "Test ELO security" 
        private void test_Click(object sender, EventArgs e)
        {
            listBox1.Items.Clear();
            fouls.Clear();
            bool status = true;
            // See if all the required fields have data in them.
            if (ELOAdmin.TextLength == 0)
            {
                status = false;
                ELOAdmin.Text = "Error no group selected";
            }
            if (ELOUser.TextLength == 0)
            {
                status = false;
                ELOUser.Text = "Error no group selected";
            }
            if (ELOArchive.TextLength == 0)
            {
                status = false;
                ELOArchive.Text = "Error no folder selected";
            }
            if (ELOGlobal.TextLength == 0)
            {
                status = false;
                ELOGlobal.Text = "Error no folder selected";
            }
            if (ELOAdminSID.Length == 0)
            {
                listBox1.Items.Add("Error in selecting admin-group.");
                listBox1.Items.Add("Please select group via the group-list.");
            }
            if (ELOUserSID.Length == 0)
            {
                listBox1.Items.Add("Error in selecting user-group.");
                listBox1.Items.Add("Please select group via the group-list.");
            }
            if (status == true)
            {
                try
                {
                    // See if the to selected paths exists.
                    if (System.IO.Directory.Exists(ELOArchive.Text) && System.IO.Directory.Exists(ELOGlobal.Text))
                    {
                        // Get the AccessControl related too the ELO archive folder.
                        System.Security.AccessControl.DirectorySecurity ArchiveSec = System.IO.Directory.GetAccessControl(ELOArchive.Text);
                        System.Security.AccessControl.AuthorizationRuleCollection AccessRules = ArchiveSec.GetAccessRules(true, true, Type.GetType("System.Security.Principal.SecurityIdentifier"));
                        // Test the archive folder fore errors.
                        if (AccessRules.Count > 1)
                        {
                            fouls.Add(1);
                        }
                        else
                        {
                            if (AccessRules[0].IdentityReference.ToString().Equals(ELOAdminSID))
                            {
                                count = 0;
                                System.Security.AccessControl.FileSystemAccessRule[] rule = new System.Security.AccessControl.FileSystemAccessRule[AccessRules.Count];
                                foreach (System.Security.AccessControl.FileSystemAccessRule rule2 in AccessRules)
                                {
                                    rule[count] = rule2;
                                    count++;

                                }
                                if (rule[0].FileSystemRights == System.Security.AccessControl.FileSystemRights.FullControl) 
                                {
                                    fouls.Add(100);
                                }
                                else
                                {
                                    fouls.Add(2);
                                }
                            }
                            else
                            {
                                fouls.Add(3);
                            }
                        }

                        // Get the AccessControl related too the ELO Global folder.
                        ArchiveSec = System.IO.Directory.GetAccessControl(ELOGlobal.Text);
                        AccessRules = ArchiveSec.GetAccessRules(true, true, Type.GetType("System.Security.Principal.SecurityIdentifier"));
                        // Test the Global folder fore errors.
                        if (AccessRules.Count > 2)
                        {
                            fouls.Add(11);
                        }
                        else
                        {
                            if (AccessRules[0].IdentityReference.ToString().Equals(ELOAdminSID))
                            {
                                if (AccessRules[1].IdentityReference.ToString().Equals(ELOUserSID))
                                {
                                    count = 0;
                                    System.Security.AccessControl.FileSystemAccessRule[] rule = new System.Security.AccessControl.FileSystemAccessRule[AccessRules.Count];
                                    foreach (System.Security.AccessControl.FileSystemAccessRule rule2 in AccessRules)
                                    {
                                        rule[count] = rule2;
                                        count++;

                                    }
                                    if (rule[0].FileSystemRights == System.Security.AccessControl.FileSystemRights.FullControl)
                                    {
                                        fouls.Add(101);
                                    }
                                    else
                                    {
                                        fouls.Add(14);
                                    }
                                    if (rule[1].FileSystemRights.ToString() == System.Security.AccessControl.FileSystemRights.ReadAndExecute.ToString() + ", " + System.Security.AccessControl.FileSystemRights.Synchronize.ToString())
                                    {
                                        fouls.Add(102);
                                    }
                                    else
                                    {
                                        fouls.Add(15);
                                    }

                                }
                                else
                                {
                                    fouls.Add(13);
                                }
                            }
                            else if (AccessRules[1].IdentityReference.ToString().Equals(ELOAdminSID))
                            {
                                if (AccessRules[0].IdentityReference.ToString().Equals(ELOUserSID))
                                {
                                    count = 0;
                                    System.Security.AccessControl.FileSystemAccessRule[] rule = new System.Security.AccessControl.FileSystemAccessRule[AccessRules.Count];
                                    foreach (System.Security.AccessControl.FileSystemAccessRule rule2 in AccessRules)
                                    {
                                        rule[count] = rule2;
                                        count++;

                                    }
                                    if (rule[1].FileSystemRights == System.Security.AccessControl.FileSystemRights.FullControl)
                                    {
                                        fouls.Add(101);
                                    }
                                    else
                                    {
                                        fouls.Add(14);
                                    }
                                    if (rule[0].FileSystemRights.ToString() == System.Security.AccessControl.FileSystemRights.ReadAndExecute + ", " + System.Security.AccessControl.FileSystemRights.Synchronize.ToString())
                                    {
                                        fouls.Add(102);
                                    }
                                    else
                                    {
                                        fouls.Add(15);
                                        listBox1.Items.Add(rule[0].FileSystemRights.ToString());
                                    }

                                }
                                else
                                {
                                    fouls.Add(13);
                                }
                            }
                            else
                            {
                                fouls.Add(12);
                            }
                        }
                    }
                    else
                    {
                        listBox1.Items.Add("The folders entered does not exits.");
                    }
                    /* Foul 1-10 is ELO archive error messages
                     * Foul 11-20 is ELO program error messages
                     * Foul 100-110 is correct messages  
                     */
                    visibelcorret = false;
                    foreach (int foul in fouls)
                    {
                        if (foul == 1)
                        {
                            listBox1.Items.Add("ERROR: There are to many groups and users assigned to ELO's archive.");
                            visibelcorret = true;
                        }
                        if (foul == 2)
                        {
                            listBox1.Items.Add("ERROR: ELO Admin-group does not have the correct access.");
                            visibelcorret = true;
                        }
                        if (foul == 3)
                        {
                            listBox1.Items.Add("ERROR: The group assigned to the ELO archive is not the selected ELO Admin group.");
                            visibelcorret = true;
                        }
                        if (foul == 11)
                        {
                            listBox1.Items.Add("ERROR: There are to many groups and users assigned to ELO's Gobal-folder.");
                            visibelcorret = true;
                        }
                        if (foul == 12)
                        {
                            listBox1.Items.Add("ERROR: The group assigned to the ELO Gobal-folder is not the selected ELO Admin group.");
                            visibelcorret = true;
                        }
                        if (foul == 13)
                        {
                            listBox1.Items.Add("ERROR: The group assigned to the ELO Gobal-folder is not the selected ELO user-group.");
                            visibelcorret = true;
                        }
                        if (foul == 14)
                        {
                            listBox1.Items.Add("ERROR: ELO Admin-group does not have the correct access.");
                            visibelcorret = true;
                        }
                        if (foul == 15)
                        {
                            listBox1.Items.Add("ERROR: ELO User-group does not have the correct access.");
                            visibelcorret = true;
                        }
                        if (foul == 100)
                        {
                            listBox1.Items.Add("CORRECT: ELO arhive has the correct setup.");
                        }
                        if (foul == 101)
                        {
                            listBox1.Items.Add("CORRECT: ELO Gobal-folder has the correct setup for the Admin-group.");
                        }
                        if (foul == 102)
                        {
                            listBox1.Items.Add("CORRECT: ELO Gobal-folder has the correct setup for the User-group.");
                        }
                        Correct.Visible = visibelcorret;
                    }
                }
                catch (Exception EXP)
                {
                    listBox1.Items.Add(EXP.Message.ToString());
                }
            }
        }
        // Function started if there is a click on button "Correct ELO settings" 
        private void Correct_Click(object sender, EventArgs e)
        {
            foreach (int foul in fouls)
            {
                if (foul > 0 && foul < 11)
                {
                    // Gets the AccessControl fore the archive folder and deletes all the accessrules.
                    System.IO.DirectoryInfo ArchiveInfo = new System.IO.DirectoryInfo(ELOArchive.Text);
                    System.Security.AccessControl.DirectorySecurity ArchiveSec = ArchiveInfo.GetAccessControl();
                    System.Security.AccessControl.AuthorizationRuleCollection AccessRules = ArchiveSec.GetAccessRules(true, true, Type.GetType("System.Security.Principal.SecurityIdentifier"));
                    foreach (System.Security.AccessControl.FileSystemAccessRule rule in AccessRules)
                    {
                        ArchiveSec.RemoveAccessRule(rule);
                    }
                    // Adds the correct accessrules to the AccessControl and loads the AccessControl
                    // to the archive folder
                    ArchiveSec.AddAccessRule(new System.Security.AccessControl.FileSystemAccessRule(new System.Security.Principal.SecurityIdentifier(ELOAdminSID), System.Security.AccessControl.FileSystemRights.FullControl, System.Security.AccessControl.InheritanceFlags.None, System.Security.AccessControl.PropagationFlags.InheritOnly, System.Security.AccessControl.AccessControlType.Allow));
                    ArchiveSec.AddAccessRule(new System.Security.AccessControl.FileSystemAccessRule(new System.Security.Principal.SecurityIdentifier(ELOAdminSID), System.Security.AccessControl.FileSystemRights.FullControl, System.Security.AccessControl.InheritanceFlags.ContainerInherit, System.Security.AccessControl.PropagationFlags.InheritOnly, System.Security.AccessControl.AccessControlType.Allow));
                    ArchiveSec.AddAccessRule(new System.Security.AccessControl.FileSystemAccessRule(new System.Security.Principal.SecurityIdentifier(ELOAdminSID), System.Security.AccessControl.FileSystemRights.FullControl, System.Security.AccessControl.InheritanceFlags.ObjectInherit, System.Security.AccessControl.PropagationFlags.InheritOnly, System.Security.AccessControl.AccessControlType.Allow));
                    ArchiveInfo.SetAccessControl(ArchiveSec);
                    
                }
                if (foul > 10 && foul < 21)
                {
                    // Gets the AccessControl fore the Global folder and deletes all the accessrules.
                    System.IO.DirectoryInfo ArchiveInfo = new System.IO.DirectoryInfo(ELOGlobal.Text);
                    System.Security.AccessControl.DirectorySecurity ArchiveSec = ArchiveInfo.GetAccessControl();
                    System.Security.AccessControl.AuthorizationRuleCollection AccessRules = ArchiveSec.GetAccessRules(true, true, Type.GetType("System.Security.Principal.SecurityIdentifier"));
                    foreach (System.Security.AccessControl.FileSystemAccessRule rule in AccessRules)
                    {
                        ArchiveSec.RemoveAccessRule(rule);
                    }
                    // Adds the correct accessrules to the AccessControl and loads the AccessControl
                    // to the Global folder
                    ArchiveSec.AddAccessRule(new System.Security.AccessControl.FileSystemAccessRule(new System.Security.Principal.SecurityIdentifier(ELOAdminSID), System.Security.AccessControl.FileSystemRights.FullControl, System.Security.AccessControl.InheritanceFlags.None, System.Security.AccessControl.PropagationFlags.InheritOnly, System.Security.AccessControl.AccessControlType.Allow));
                    ArchiveSec.AddAccessRule(new System.Security.AccessControl.FileSystemAccessRule(new System.Security.Principal.SecurityIdentifier(ELOAdminSID), System.Security.AccessControl.FileSystemRights.FullControl, System.Security.AccessControl.InheritanceFlags.ContainerInherit, System.Security.AccessControl.PropagationFlags.InheritOnly, System.Security.AccessControl.AccessControlType.Allow));
                    ArchiveSec.AddAccessRule(new System.Security.AccessControl.FileSystemAccessRule(new System.Security.Principal.SecurityIdentifier(ELOAdminSID), System.Security.AccessControl.FileSystemRights.FullControl, System.Security.AccessControl.InheritanceFlags.ObjectInherit, System.Security.AccessControl.PropagationFlags.InheritOnly, System.Security.AccessControl.AccessControlType.Allow));
                    ArchiveSec.AddAccessRule(new System.Security.AccessControl.FileSystemAccessRule(new System.Security.Principal.SecurityIdentifier(ELOUserSID), System.Security.AccessControl.FileSystemRights.ReadAndExecute, System.Security.AccessControl.InheritanceFlags.None, System.Security.AccessControl.PropagationFlags.InheritOnly, System.Security.AccessControl.AccessControlType.Allow));
                    ArchiveSec.AddAccessRule(new System.Security.AccessControl.FileSystemAccessRule(new System.Security.Principal.SecurityIdentifier(ELOUserSID), System.Security.AccessControl.FileSystemRights.ReadAndExecute, System.Security.AccessControl.InheritanceFlags.ContainerInherit, System.Security.AccessControl.PropagationFlags.InheritOnly, System.Security.AccessControl.AccessControlType.Allow));
                    ArchiveSec.AddAccessRule(new System.Security.AccessControl.FileSystemAccessRule(new System.Security.Principal.SecurityIdentifier(ELOUserSID), System.Security.AccessControl.FileSystemRights.ReadAndExecute, System.Security.AccessControl.InheritanceFlags.ObjectInherit, System.Security.AccessControl.PropagationFlags.InheritOnly, System.Security.AccessControl.AccessControlType.Allow));
                    ArchiveInfo.SetAccessControl(ArchiveSec);
                }
            }
            Correct.Visible = false;
        }     
    }
}